library PlayerAConverter_Automatic;

uses
  Windows,
  SysUtils,
  Classes,
  //vcl.Dialogs,
  PlayerConvertUnit in 'PlayerConvertUnit.pas';

{$E ASI}

{$R *.res}

procedure DllMain(reason: Integer);
var
  bytesProcessed: NativeUInt;
  buf: DWORD;
  FileName: string;
begin
  if reason = DLL_PROCESS_ATTACH then
  begin
    FileName := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0))) + '..\gtadata\player_a.dat';
    if not FileExists(FileName) then exit;

    ReadProcessMemory(GetCurrentProcess, Pointer($405000), Pointer(@buf), sizeof(buf), bytesProcessed);
    if bytesProcessed <> sizeof(buf) then exit;
    // showmessage(IntToHex(buf,8));

    if buf = $7D03FFFF then
    begin
      // GTA Classic
      ConvertTo(FileName, geClassic);
    end
    else if buf = $0000008B then
    begin
      // GTA Retail
      ConvertTo(FileName, geRetail);
    end
    else
    begin
      // Something else. Do nothing.
    end;
  end;
end;

begin
  DllProc := DllMain;
  DllMain(DLL_PROCESS_ATTACH);
end.
